PROGRAM_NAME='sv3000jon,Rev 2'
(*{{PS_SOURCE_INFO(PROGRAM STATS)                          *)
(***********************************************************)
(*  FILE CREATED ON: 06/01/2002 AT: 12:25:07               *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 07/23/2002 AT: 10:19:43         *)
(***********************************************************)
(*  ORPHAN_FILE_PLATFORM: 0                                *)
(***********************************************************)
(*!!FILE REVISION: Rev 2                                   *)
(*  REVISION DATE: 06/24/2002                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*  Compensating for Axcess lack of negative numbers.      *)
(***********************************************************)
(*!!FILE REVISION: Rev 1                                   *)
(*  REVISION DATE: 06/13/2002                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*  Post Infocomm                                          *)
(***********************************************************)
(*!!FILE REVISION: Rev 0                                   *)
(*  REVISION DATE: 06/01/2002                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*                                                         *)
(***********************************************************)
(*}}PS_SOURCE_INFO                                         *)
(***********************************************************)

(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

SuperView   = 32:1:1     (* 232 : 9600,n,8,1 *)
TP          = 128:1:0

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT


TRUE             = 1
FALSE            = 0

MULTIPLIER       = 4

(*---------------------------------------------------------*)
(* THE FOLLOWING CONSTANTS REPRESENT FUNCTIONALITY AND/OR  *)
(* COMMANDS THAT THE SUPERVIEW 3000 OFFERS.  THEY ARE      *)
(* ASSIGNED TO THE 'ACTION' VARIABLE TO KEEP TRACK OF WHAT *)
(* OPERATIONS ARE IN PROCESS                               *)
(*                                                         *)
(* THE CONSTANTS ARE ALSO USED AS INDEXES TO THE SETTINGS  *)
(* ARRAY TO HOLD ALL OF THE SUPERVIEWS VALUES, RETRIEVED   *)
(* IN THE STARTUP MODE                                     *)
(*---------------------------------------------------------*)
(* HOST Commands *)
HOST             = 1
HOST_INTERACTIVE = 2
HOST_LIST        = 3
HOST_LOAD        = 4
HOST_NAME        = 5
HOST_SAVE        = 6
HOST_TIMING      = 7

(* RGB Input Commands *)
INTYPE           = 8
RGB_INPUT        = 9
RGB_INPUT_INTERACTIVE = 10
RGB_INPUT_LIST   = 11
RGB_INPUT_LOAD   = 12
RGB_INPUT_NAME   = 13
RGB_INPUT_SAVE   = 14
RGB_INPUT_TIMING = 15

(* Window Positioning/Visibility *)
POS              = 16
ZOOM             = 17
PAN              = 18
MOVE             = 19
RESIZE           = 20
PRIORITY         = 21
PRIORITY_ALL     = 22
WDR              = 23
SET_WINDOW       = 24
SET_WINDOW_ALL   = 25
WSR              = 26
BACKGROUND       = 27
WIN_ID           = 28
TESTPATTERN      = 29
RSR              = 30

(* Image Control *)
BRIGHT           = 31
CHROMA_KEY       = 32
CHROMAKEY_COLOR  = 33
CONTRAST         = 34
FREEZE           = 35
FREEZE_ALL       = 36
SATURATION       = 37
SHARPNESS        = 38
GAMMA            = 39
HUE              = 40
INPUT            = 41
OVERSCAN         = 42

(* Serial Port Functions *)
BAUD_RATE        = 43
ECHO             = 44

SETUP            = 45
SUPERVIEW_DEMO   = 46

(* Misc Commands *)
DEMO             = 47
AUTO_DEMO        = 48
FRONT_PANEL      = 49
HELP             = 50
ID               = 51
RESTORE_DEFAULT  = 52
SETRATE          = 53
SAVECONFIG       = 54

(* TYPE INDEXES *)
WDR_X_POS        = 55
WDR_Y_POS        = 56
WDR_WIDTH        = 57
WDR_HEIGHT       = 58
WSR_X_POS        = 59
WSR_Y_POS        = 60
WSR_WIDTH        = 61
WSR_HEIGHT       = 62
INPUT_RES_WIDTH  = 63
INPUT_RES_HEIGHT = 64
OUTPUT_RES_WIDTH = 65
OUTPUT_RES_HEIGHT= 66

FF_MOVE_UP       = 100
FF_MOVE_DOWN     = 101
FF_MOVE_LEFT     = 102
FF_MOVE_RIGHT    = 103
RESIZE_BIG_4TO3  = 104
RESIZE_SMALL_4TO3= 105
RESIZE_BIG_16TO9 = 106
RESIZE_SMALL_16TO9=107
ZOOM_IN          = 108
ZOOM_OUT         = 109
FF_ZOOM_IN       = 110
FF_ZOOM_OUT      = 111
FF_PAN_LEFT     = 112
FF_PAN_RIGHT    = 113
FF_PAN_UP       = 114
FF_PAN_DOWN     = 115


(* INCORRECT, but necessary for demo mode currently *)
TOTAL_WINDOWS    = 4

(* Indexes for SETTINGS array *)
OUTPUT           = 1

(* INPUT TYPES *)
COMPOSITE        = 1
RGB              = 2
SVIDEO           = 3
ERROR            = 4

(* TEST PATTERN TYPES *)
COLORBARS        = 1
GRAYSCALE        = 2
MOVINGBARS       = 3
NOPATTERN        = 4

AUTO             = 1
FREE             = 2

(* DEMO MODES *)
SV_DEMO_1        = 1
SV_DEMO_2        = 2
SV_DEMO_3        = 3
SV_DEMO_4        = 4
SV_DEMO_5        = 5
SV_DEMO_6        = 6

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

SV_BUFFER[255] (* CONTAINS THE OUTPUT FROM THE SUPERVIEW *)
TP_BUFFER[255] (* CONTAINS THE OUTPUT FROM THE TOUCH PANEL *)

(* STRINGS USED TO HOLD DIFFERENT ELEMENTS OF THE SV_BUFFER DURING STARTUP *)
SV_STRING[255]  
STR[70]
TRASH[100]

NUM[10]  (* HOLDS THE TOUCH PANEL OUTPUT FROM THE KEYPAD *)
NAME[50] (* HOLDS THE TOUCH PANEL OUTPUT FROM THE KEYBOARD *)
NEW_X[10]
NEW_Y[10]

PIXEL_JUMP (* HOLDS THE SUPERVIEWS SETRATE VALUE *)
X_LEVEL
Y_LEVEL
PRESET   (* HOLDS WHICH WINDOW ARRANGEMENT PRESET IS DISPLAYED *)

WINDOW   (* THE SUPERVIEW WINDOW CURRENTLY SELECTED *)
DATA_STR[70] (* OUTPUT STRING GIVEN TO THE SUPERVIEW *)

(*---------------------------------------------------------*)
(* THE SETTINGS ARRAY HOLDS ALL OF THE SUPERVIEWS VALUES   *)
(* SUCH AS WINDOW POSITION, BRIGHTNESS, CONTRAST AS WELL   *)
(* AS HOST VALUES.                                         *)
(*                                                         *)
(* THE ARRAY IS INDEXED AS FOLLOWS:                        *)
(*          [WINDOW/OUTPUT][SETTING]                       *)
(*---------------------------------------------------------*)
INTEGER SETTINGS[12][70] 

(* THE ACTION VARIABLE REFERS TO THE CURRENT TASK BEING  *)
(* PROCESSED BY THE SUPERVIEW 3000.  THESE TASKS ARE     *)
(* DEFINED AS CONSTANTS                                  *)
ACTION

MENU (* REFERS TO THE CURRENT MENU SELECTED ON THE TOUCH PANEL *)
INPUT_LEVEL_GRAPH (* SLIDE BAR FOR THE INPUT LEVELS MENU ON THE TP *)
OUTPUT_GAMMA_GRAPH (* GAMMA SLIDE BAR *)
STEP (* VARIABLE USED FOR THE AUTO DEMO MODE *)

X (* VARIABLE USED FOR MISCELLANEOUS VALUES *)
Y (* VARIABLE USED FOR MISCELLANEOUS VALUES *)

(* VARIABLES USED FOR READING IN VALUES FOR THE *)
(* HOST MODE IN THE SUPERVIEW                   *)
TOTAL_WIDTH   (* TOTAL OUTPUT PIXELS *)
TOTAL_HEIGHT  (* TOTAL OUTPUT LINES  *)
SINGLE_WIDTH  (* 1/4 SCREEN WIDTH    *)
SINGLE_HEIGHT (* 1/4 SCREEN HEIGHT   *)
MAIN_WIDTH    (* 2/3 SCREEN WIDTH    *)
MAIN_HEIGHT   (* 2/3 SCREEN HEIGHT   *)

(*---------------------------------------------------------*)
(* REPRESENTS ZERO FOR THE X,Y COORDINATES OF EACH WINDOW. *)
(* THIS IS A VARIABLE BECAUSE OF THE LOGIC USED TO FAKE    *)
(* NEGATIVE NUMBERS DUE TO AXCESS LACKING.                 *)
(*                                                         *)
(* THE LOGIC FOR NEGATIVE REPRESENTATION IS AS FOLLOWS:    *)
(*    TOTAL_WIDTH * MULTIPLIER  =  LARGEST POSSIBLE WIDTH  *)
(*    TOTAL_HEIGHT * MULTIPLIER = LARGEST POSSIBLE HEIGHT  *)
(*    TOTAL_HEIGHT * (MULTIPLIER/2) = ZERO          *)
(*---------------------------------------------------------*)
WDR_X_ZERO
WDR_Y_ZERO
(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*           SUBROUTINE DEFINITIONS GO BELOW               *)
(***********************************************************)

(*---------------------------------------------------------*)
(* Function: SVWIN00F                                      *)
(*   This function is responsible for all communication    *)
(*   with the SuperView.  All commands to the SuperView    *)
(*   should be executed through this function.             *)
(* Variables:                                              *)
(*   DEVICE  - the device to which the function outputs    *)
(*             to, this is extremely helpful when          *)
(*             controlling multiple SuperViews             *)
(*   FUNC    - the command that is to be executed          *)
(*   DATA[]  - the options for the command                 *)
(*   OFFSET  - the offset, defaults to 13 (new line)       *)
(*---------------------------------------------------------*)
DEFINE_CALL 'SVWIN00F' (DEV DEVICE,FUNC,DATA[50],OFFSET)
LOCAL_VAR CMD_STR[59]
{
  SELECT
  {
     ACTIVE (FUNC = HOST) :
     {
        IF (LENGTH_STRING(DATA))
           CMD_STR = "'HOST ',DATA,13"
        ELSE
           CMD_STR = "'HOST',13"
        (* DATA = 'AUTO' or 'FREE' or 'LOCK' *)
     }
     ACTIVE (FUNC = HOST_INTERACTIVE) :
     {
        CMD_STR = "'HI',13"
     }
     ACTIVE (FUNC = RGB_INPUT_INTERACTIVE) :
     {
        (* DATA = <WINDOW> *)
        CMD_STR = "'INI ',DATA,13"
     }
     ACTIVE (FUNC = TESTPATTERN) :
     {
        (* DATA = <COLORBARS/GRAYSCALE/MOVINGBARS/OFF> *)
        CMD_STR = "'TESTPATTERN ',DATA,13"
     }
     ACTIVE (FUNC = RSR) :
     {
        CMD_STR = "'RSR ',DATA,13"
        (* DATA = <WINDOW> *)
     }
     ACTIVE (FUNC = WSR) :
     {
        CMD_STR = "'WSR ',DATA,13"
        (* DATA = <WINDOW#> <X> <Y> <WIDTH> <HEIGHT> *)
     }
     ACTIVE (FUNC = WDR) :
     {
        (* DATA = <WINDOW#> <X> <Y> <WIDTH> <HEIGHT> or
           DATA = <WINDOW#> *)
        CMD_STR = "'WDR ',DATA,13"
     }
     ACTIVE (FUNC = PRIORITY) :
     {
        (* DATA = <WINDOW#> <1..6> *)
        CMD_STR = "'PRI ',DATA,13"
     }
     ACTIVE (FUNC = PRIORITY_ALL) :
     {
        (* DATA = <ALL> <1..6> <1..6> <1..6> <1..6> <1..6> <1..6> *)
        CMD_STR = "'PRI ALL ',DATA,13"
     }
     ACTIVE (FUNC = SET_WINDOW) :
     {
        (* DATA = <WINDOW#> <ON/OFF> *)
        CMD_STR = "'win ',DATA,13"
     }
     ACTIVE (FUNC = SET_WINDOW_ALL) :
     {
        (* DATA = <ON/OFF> *)
        CMD_STR = "'win all ',DATA,13"
     }
     ACTIVE (FUNC = BACKGROUND) :
     {
        (* DATA = <ON/OFF> *)
        CMD_STR = "'background ',DATA,13"
     }
     ACTIVE (FUNC = FREEZE) :
     {
        (* DATA = <WINDOW#> <ON/OFF> *)
        CMD_STR = "'freeze ',DATA,13"
     }
     ACTIVE (FUNC = FREEZE_ALL) :
     {
        (* DATA = <ON/OFF> *)
        CMD_STR = "'freeze all ',DATA,13"
     }
     ACTIVE (FUNC = ECHO) :
     {
        (* DATA = <ON/OFF> *)
        CMD_STR = "'ECHO ',DATA,13"
     }
     ACTIVE (FUNC = RGB_INPUT) :
     {
        (* DATA = <WINDOW #> *)
        CMD_STR = "'rgbinput ',DATA,13"
     }
     ACTIVE (FUNC = WIN_ID) :
     {
        (* DATA = <WINDOW #> *)
        CMD_STR = "'WINID ',DATA,13"
     }
     ACTIVE (FUNC = INTYPE) :
     {
        (* DATA = <WINDOW #> <SVIDEO/COMPOSITE/RGB> 
           DATA = <WINDOW #> *)
        CMD_STR = "'intype ',DATA,13"
     }
     ACTIVE (FUNC = OVERSCAN) :
     {
        (* DATA = <WINDOW> <ON/OFF> *)
        CMD_STR = "'overscan ',DATA,13"
     }
     ACTIVE (FUNC = BRIGHT) :
     {
        (* DATA = <WINDOW#> <BRIGHTNESS#> 
           DATA = <WINDOW#> *)
        CMD_STR = "'bri ',DATA,13"
     }
     ACTIVE (FUNC = CONTRAST) :
     {
        (* DATA = <WINDOW#> <CONTRAST#> 
           DATA = <WINDOW#> *)
        CMD_STR = "'cont ',DATA,13"
     }
     ACTIVE (FUNC = SATURATION) :
     {
        (* DATA = <WINDOW#> <SATURATION#> 
           DATA = <WINDOW#> *)
        CMD_STR = "'sat ',DATA,13"
     }
     ACTIVE (FUNC = HUE) :
     {
        (* DATA = <WINDOW#> <HUE#> 
           DATA = <WINDOW#> *)
        CMD_STR = "'hue ',DATA,13"
     }
     ACTIVE (FUNC = SHARPNESS) :
     {
        (* DATA = <WINDOW#> <SHARPNESS#> 
           DATA = <WINDOW#> *)
        CMD_STR = "'sharp ',DATA,13"
     }
     ACTIVE (FUNC = GAMMA) :
     {
        (* DATA = <WINDOW#> <GAMMA#> 
           DATA = <WINDOW#> *)
        CMD_STR = "'gam ',DATA,13"
     }
     ACTIVE (FUNC = SETRATE) :
     {
        IF (LENGTH_STRING(DATA))
           CMD_STR = "'setrate ',DATA,13"
        ELSE
           CMD_STR = "'setrate',13"
        (* DATA = <X> <Y> *)
     }
     ACTIVE (FUNC = SAVECONFIG) :
     {
        CMD_STR = "'saveconfig',13"
     }
     ACTIVE (FUNC = POS) :
     {
        (* DATA = <WINDOW #> <DIRECTION> <# OF MOVEMENTS IN DIRECTION>
           DIRECTION = J (LEFT), L (RIGHT), I (UP), M (DOWN) *)
        CMD_STR = "'pos ',DATA,13"
     }
  }
  SEND_STRING DEVICE,CMD_STR
  IF ([DEVICE,250])                (* !!REV1 TX DEBUG *)
    SEND_STRING 0,"'-> DEV',ITOA(DEVICE),': ',CMD_STR,10"
}
(*---------------------------------------------------------*)
(* Function: REPORT BRIGHTNESS                             *)
(*   This function converts the brightness to negative     *)
(*   values if needed to be reported to the touch panel.   *)
(* Variables:                                              *)
(*   WIN  - the window currently being examined            *)
(*---------------------------------------------------------*)
DEFINE_CALL 'REPORT BRIGHTNESS' (DEV DEVICE, WIN)
{
     IF (SETTINGS[WIN][BRIGHT] < 510)
       STR = "'-',ITOA( (510-SETTINGS[WIN][BRIGHT]) )"
     ELSE
       STR = ITOA( (SETTINGS[WIN][BRIGHT]-510) )
     CALL 'SVWIN00F' (DEVICE,BRIGHT,"ITOA(WIN),' ',STR",0)
     SEND_COMMAND TP,"'!T',3,STR"
}

(*---------------------------------------------------------*)
(* Function: Setup Coords                                  *)
(*   This function converts the input integers into a      *)
(*   string, which SVWIN00F requires for output.           *)
(* Variables:                                              *)
(*   WIN    - the window currently being altered           *)
(*   _X     - the integer x/width/pixel position           *)
(*   _Y     - the integer y/height/line position           *)
(*   _W     - the integer width                            *)
(*   _H     - the integer height                           *)
(*   DATA[] - the temporary string to hold the converted   *)
(*            values                                       *)
(*---------------------------------------------------------*)
DEFINE_CALL 'Setup Coords' (WIN,_X,_Y,_W,_H,DATA[70])
{
     DATA = "ITOA(WIN),' ',ITOA(_X),' ',ITOA(_Y),' ',
                           ITOA(_W),' ',ITOA(_H)"
}
(*---------------------------------------------------------*)
(* Function: Setup WDR Coords                              *)
(*   This function converts the input integers into a      *)
(*   string, which SVWIN00F requires for output.  It also  *)
(*   converts the X and Y positions into meaningful values *)
(*   for the SuperView.                                    *)
(* Variables:                                              *)
(*   WIN  - the window currently being examined            *)
(*   _X     - the integer x/width/pixel position           *)
(*   _Y     - the integer y/height/line position           *)
(*   _W     - the integer width                            *)
(*   _H     - the integer height                           *)
(*   DATA[] - the temporary string to hold the converted   *)
(*            values                                       *)
(*---------------------------------------------------------*)
DEFINE_CALL 'Setup WDR Coords' (WIN,_X,_Y,_W,_H,DATA[70])
{
     CALL 'Negative WDR Converter' (WDR_X_ZERO, WDR_Y_ZERO,_X,_Y)
     DATA = "ITOA(WIN),' ',NEW_X,' ',NEW_Y,' ',
             ITOA(_W),' ',ITOA(_H)"
}
(*---------------------------------------------------------*)
(* Function: Negative WDR Converter                        *)
(*   This function converts the WDR coordinates to negative*)
(*   values for the SuperView's WDR command.               *)
(* Variables:                                              *)
(*   X_ZERO - the relative zero point for the WDR X        *)
(*            position, before being converted into zero   *)
(*            as the SuperView will interpret it (0)       *)
(*   Y_ZERO - the relative zero point for the WDR Y        *)
(*            position, before being converted into zero   *)
(*            as the SuperView will interpret it (0)       *)
(*   _X     - the unconverted x coordinate                 *)
(*   _Y     - the unconverted y coordinate                 *)
(*---------------------------------------------------------*)
DEFINE_CALL 'Negative WDR Converter' (X_ZERO,Y_ZERO,_X,_Y)
{
  IF ( _X < X_ZERO )
    NEW_X = "'-',ITOA( (X_ZERO - _X) )"
  ELSE
    NEW_X = "ITOA( (_X - X_ZERO) )"  

  IF ( _Y < Y_ZERO )
    NEW_Y = "'-',ITOA( (Y_ZERO - _Y) )"
  ELSE
    NEW_Y = "ITOA( (_Y - Y_ZERO) )"  
}

DEFINE_CALL 'RUN SV DEMO 1'  (* 4 windows slide in from off the screen *)
{
  PRESET = 1
  CALL 'SVWIN00F' (SuperView,SET_WINDOW_ALL,"'OFF'",0)  
  SETTINGS[1][WDR_X_POS] = WDR_X_ZERO - (TOTAL_WIDTH/3)
  SETTINGS[1][WDR_Y_POS] = WDR_Y_ZERO + 50
  SETTINGS[1][WDR_WIDTH] = TOTAL_WIDTH/3
  SETTINGS[1][WDR_HEIGHT] = TOTAL_HEIGHT/3
  SEND_STRING SuperView,"'wdr 1 -',ITOA(TOTAL_WIDTH/3),' 50 ',ITOA(TOTAL_WIDTH/3),' ',ITOA(TOTAL_HEIGHT/3),13"
 
  SETTINGS[2][WDR_X_POS] = WDR_X_ZERO + TOTAL_WIDTH
  SETTINGS[2][WDR_Y_POS] = WDR_Y_ZERO + 50
  SETTINGS[2][WDR_WIDTH] = TOTAL_WIDTH/3
  SETTINGS[2][WDR_HEIGHT] = TOTAL_HEIGHT/3
  CALL 'Setup Coords' (2,TOTAL_WIDTH,50,TOTAL_WIDTH/3,TOTAL_HEIGHT/3,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[3][WDR_X_POS] = WDR_X_ZERO - (TOTAL_WIDTH/3)
  SETTINGS[3][WDR_Y_POS] = (TOTAL_HEIGHT-50-(TOTAL_HEIGHT/3)) + WDR_Y_ZERO
  SETTINGS[3][WDR_WIDTH] = TOTAL_WIDTH/3
  SETTINGS[3][WDR_HEIGHT] = TOTAL_HEIGHT/3
  SEND_STRING SuperView,"'wdr 3 -',ITOA(TOTAL_WIDTH/3),' ',ITOA(TOTAL_HEIGHT-50-(TOTAL_HEIGHT/3)),' ',ITOA(TOTAL_WIDTH/3),' ',ITOA(TOTAL_HEIGHT/3),13"

  SETTINGS[4][WDR_X_POS] = WDR_X_ZERO + TOTAL_WIDTH
  SETTINGS[4][WDR_Y_POS] = (TOTAL_HEIGHT-50-(TOTAL_HEIGHT/3)) + WDR_Y_ZERO
  SETTINGS[4][WDR_WIDTH] = TOTAL_WIDTH/3
  SETTINGS[4][WDR_HEIGHT] = TOTAL_HEIGHT/3
  CALL 'Setup Coords' (4,TOTAL_WIDTH,(TOTAL_HEIGHT-50-(TOTAL_HEIGHT/3)),TOTAL_WIDTH/3,TOTAL_HEIGHT/3,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'SVWIN00F' (SuperView,SET_WINDOW,"'1 ON'",0)
  CALL 'SVWIN00F' (SuperView,SET_WINDOW,"'2 ON'",0)
  CALL 'SVWIN00F' (SuperView,SET_WINDOW,"'3 ON'",0)
  CALL 'SVWIN00F' (SuperView,SET_WINDOW,"'4 ON'",0)
  SEND_STRING SuperView,"'setrate 35 35',13"

  WAIT 30
  {
  (* MOVEMENT *)
      X = 0
      WHILE (SETTINGS[1][WDR_X_POS] < (50+WDR_X_ZERO))
      {
        SETTINGS[1][WDR_X_POS] = SETTINGS[1][WDR_X_POS]+PIXEL_JUMP
        X = X + 1
      } 
    SEND_STRING SuperView,"'pos 1 l ',ITOA(X),13"
  }  
  WAIT 31 
  {
    X = 0
    WHILE (SETTINGS[2][WDR_X_POS] > ( (WDR_X_ZERO+TOTAL_WIDTH)-SETTINGS[2][WDR_WIDTH]-50) )
    {
      SETTINGS[2][WDR_X_POS] = SETTINGS[2][WDR_X_POS]-PIXEL_JUMP
      X = X+1
    }
    SEND_STRING SuperView,"'pos 2 j ',ITOA(X),13"
  }
  WAIT 32
  {
    X = 0
    WHILE (SETTINGS[3][WDR_X_POS] < (50+WDR_X_ZERO))
    {
      SETTINGS[3][WDR_X_POS] = SETTINGS[3][WDR_X_POS]+PIXEL_JUMP
      X = X + 1
    }
    SEND_STRING SuperView,"'pos 3 l ',ITOA(X),13"
  }
  WAIT 33
  {
    X = 0
    WHILE (SETTINGS[4][WDR_X_POS] > ( (WDR_X_ZERO+TOTAL_WIDTH)-SETTINGS[4][WDR_WIDTH]-50) )
    {
      SETTINGS[4][WDR_X_POS] = SETTINGS[4][WDR_X_POS]-PIXEL_JUMP
      X = X+1
    }
    SEND_STRING SuperView,"'pos 4 j ',ITOA(X),13"
  }
  (* END MOVEMENT *)
}

DEFINE_CALL 'RUN SV DEMO 2' (* 1 BIG, FIVE LITTLE *)
{
  PRESET = 2
  CALL 'SVWIN00F' (SuperView,SET_WINDOW_ALL,"'OFF'",0)
  
  SETTINGS[1][WDR_X_POS]  = WDR_X_ZERO
  SETTINGS[1][WDR_Y_POS]  = WDR_Y_ZERO
  SETTINGS[1][WDR_WIDTH]  = MAIN_WIDTH
  SETTINGS[1][WDR_HEIGHT] = MAIN_HEIGHT
  CALL 'Setup Coords' (1,0,0,MAIN_WIDTH,MAIN_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[2][WDR_X_POS]  = MAIN_WIDTH + WDR_X_ZERO
  SETTINGS[2][WDR_Y_POS]  = WDR_Y_ZERO
  SETTINGS[2][WDR_WIDTH]  = SINGLE_WIDTH
  SETTINGS[2][WDR_HEIGHT] = SINGLE_HEIGHT
  CALL 'Setup Coords' (2,MAIN_WIDTH,0,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[3][WDR_X_POS]  = MAIN_WIDTH + WDR_X_ZERO
  SETTINGS[3][WDR_Y_POS]  = SINGLE_HEIGHT + WDR_Y_ZERO
  SETTINGS[3][WDR_WIDTH]  = SINGLE_WIDTH
  SETTINGS[3][WDR_HEIGHT] = SINGLE_HEIGHT
  CALL 'Setup Coords' (3,MAIN_WIDTH,SINGLE_HEIGHT,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[4][WDR_X_POS]  = MAIN_WIDTH + WDR_X_ZERO
  SETTINGS[4][WDR_Y_POS]  = MAIN_HEIGHT + WDR_Y_ZERO
  SETTINGS[4][WDR_WIDTH]  = SINGLE_WIDTH
  SETTINGS[4][WDR_HEIGHT] = SINGLE_HEIGHT
  CALL 'Setup Coords' (4,MAIN_WIDTH,MAIN_HEIGHT,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[5][WDR_X_POS]  = SINGLE_WIDTH + WDR_X_ZERO
  SETTINGS[5][WDR_Y_POS]  = MAIN_HEIGHT + WDR_Y_ZERO
  SETTINGS[5][WDR_WIDTH]  = SINGLE_WIDTH
  SETTINGS[5][WDR_HEIGHT] = SINGLE_HEIGHT
  CALL 'Setup Coords' (5,SINGLE_WIDTH,MAIN_HEIGHT,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[6][WDR_X_POS]  = MAIN_WIDTH + WDR_X_ZERO
  SETTINGS[6][WDR_Y_POS]  = SINGLE_WIDTH + WDR_Y_ZERO
  SETTINGS[6][WDR_WIDTH]  = SINGLE_WIDTH
  SETTINGS[6][WDR_HEIGHT] = SINGLE_HEIGHT
  CALL 'Setup Coords' (6,0,MAIN_HEIGHT,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'SVWIN00F' (SuperView,SET_WINDOW_ALL,"'ON'",0)
}

DEFINE_CALL 'RUN SV DEMO 3' (* Rotating Quad *)
{
  PRESET = 3
  CALL 'SVWIN00F' (SuperView,SET_WINDOW_ALL,"'OFF'",0)
  CALL 'SVWIN00F' (SuperView,PRIORITY,"'4 1'",0)
  SEND_STRING SuperView,"'setrate 35 35',13"
  
  SETTINGS[1][WDR_X_POS]  = WDR_X_ZERO
  SETTINGS[1][WDR_Y_POS]  = WDR_Y_ZERO
  SETTINGS[1][WDR_WIDTH]  = TOTAL_WIDTH/2
  SETTINGS[1][WDR_HEIGHT] = TOTAL_HEIGHT/2
  CALL 'Setup Coords' (1,0,0,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[2][WDR_X_POS]  = (TOTAL_WIDTH/2) + WDR_X_ZERO
  SETTINGS[2][WDR_Y_POS]  = WDR_Y_ZERO
  SETTINGS[2][WDR_WIDTH]  = TOTAL_WIDTH/2
  SETTINGS[2][WDR_HEIGHT] = TOTAL_HEIGHT/2
  CALL 'Setup Coords' (2,TOTAL_WIDTH/2,0,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[3][WDR_X_POS]  = WDR_X_ZERO
  SETTINGS[3][WDR_Y_POS]  = (TOTAL_HEIGHT/2) + WDR_Y_ZERO
  SETTINGS[3][WDR_WIDTH]  = TOTAL_WIDTH/2
  SETTINGS[3][WDR_HEIGHT] = TOTAL_HEIGHT/2
  CALL 'Setup Coords' (3,0,TOTAL_HEIGHT/2,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)
  
  SETTINGS[4][WDR_X_POS]  = (TOTAL_WIDTH/2) + WDR_X_ZERO
  SETTINGS[4][WDR_Y_POS]  = (TOTAL_HEIGHT/2) + WDR_Y_ZERO
  SETTINGS[4][WDR_WIDTH]  = TOTAL_WIDTH/2
  SETTINGS[4][WDR_HEIGHT] = TOTAL_HEIGHT/2
  CALL 'Setup Coords' (4,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,TOTAL_WIDTH/2,TOTAL_HEIGHT/2,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'SVWIN00F' (SuperView,SET_WINDOW,"'1 ON'",0)
  CALL 'SVWIN00F' (SuperView,SET_WINDOW,"'2 ON'",0)
  CALL 'SVWIN00F' (SuperView,SET_WINDOW,"'3 ON'",0)
  CALL 'SVWIN00F' (SuperView,SET_WINDOW,"'4 ON'",0)

(* MOVEMENT *)
  WAIT 50 
  { 
    CALL 'SVWIN00F' (SuperView,BACKGROUND,"'OFF'",0)

    (* LOOP 1 *)
    WAIT 1
    {
      X = 0
      WHILE (SETTINGS[1][WDR_X_POS] < ((TOTAL_WIDTH/2)+WDR_X_ZERO) )
      {
        SETTINGS[1][WDR_X_POS] = SETTINGS[1][WDR_X_POS]+PIXEL_JUMP
        X = X + 1
      }
      SEND_STRING SuperView,"'pos 1 l ',ITOA(X),13"
    }
    WAIT 2
    { 
      X = 0
      WHILE (SETTINGS[2][WDR_Y_POS] < ((TOTAL_HEIGHT/2)+WDR_Y_ZERO) )
      {
        SETTINGS[2][WDR_Y_POS] = SETTINGS[2][WDR_Y_POS]+PIXEL_JUMP
        X = X + 1
      }
      SEND_STRING SuperView,"'pos 2 m ',ITOA(X),13"
    }
    WAIT 3
    {
      X = 0
      WHILE (SETTINGS[4][WDR_X_POS] > WDR_X_ZERO )
      {
        SETTINGS[4][WDR_X_POS] = SETTINGS[4][WDR_X_POS]-PIXEL_JUMP
        X = X + 1
      }
      SEND_STRING SuperView,"'pos 4 j ',ITOA(X),13"  
    }
    WAIT 4
    {
      X = 0
      WHILE (SETTINGS[3][WDR_Y_POS] > WDR_Y_ZERO )
      {
        SETTINGS[3][WDR_Y_POS] = SETTINGS[3][WDR_Y_POS]-PIXEL_JUMP
        X = X + 1
      }
      SEND_STRING SuperView,"'pos 3 i ',ITOA(X),13"
    }
    (* LOOP 2 *)
    WAIT 5
    {
      X = 0
      WHILE (SETTINGS[3][WDR_X_POS] < ((TOTAL_WIDTH/2)+WDR_X_ZERO) )
      {
        SETTINGS[3][WDR_X_POS] = SETTINGS[3][WDR_X_POS]+PIXEL_JUMP
        X = X + 1
      }
      SEND_STRING SuperView,"'pos 3 l ',ITOA(X),13"
    }
    WAIT 6
    { 
      X = 0
      WHILE (SETTINGS[1][WDR_Y_POS] < ((TOTAL_HEIGHT/2)+WDR_Y_ZERO) )
      {
        SETTINGS[1][WDR_Y_POS] = SETTINGS[1][WDR_Y_POS]+PIXEL_JUMP
        X = X + 1
      }
      SEND_STRING SuperView,"'pos 1 m ',ITOA(X),13"
    }
    WAIT 7
    {
      X = 0
      WHILE (SETTINGS[2][WDR_X_POS] > WDR_X_ZERO )
      {
        SETTINGS[2][WDR_X_POS] = SETTINGS[2][WDR_X_POS]-PIXEL_JUMP
        X = X + 1
      }
      SEND_STRING SuperView,"'pos 2 j ',ITOA(X),13"  
    }
    WAIT 8
    {
      X = 0
      WHILE (SETTINGS[4][WDR_Y_POS] > WDR_Y_ZERO )
      {
        SETTINGS[4][WDR_Y_POS] = SETTINGS[4][WDR_Y_POS]-PIXEL_JUMP
        X = X + 1
      }
      SEND_STRING SuperView,"'pos 4 i ',ITOA(X),13"
    }
    (* LOOP 3 *)
    WAIT 9
    {
      X = 0
      WHILE (SETTINGS[4][WDR_X_POS] < ((TOTAL_WIDTH/2)+WDR_X_ZERO) )
      {
        SETTINGS[4][WDR_X_POS] = SETTINGS[4][WDR_X_POS]+PIXEL_JUMP
        X = X + 1
      }
      SEND_STRING SuperView,"'pos 4 l ',ITOA(X),13"
    }
    WAIT 10
    { 
      X = 0
      WHILE (SETTINGS[3][WDR_Y_POS] < ((TOTAL_HEIGHT/2)+WDR_Y_ZERO) )
      {
        SETTINGS[3][WDR_Y_POS] = SETTINGS[3][WDR_Y_POS]+PIXEL_JUMP
        X = X + 1
      }
      SEND_STRING SuperView,"'pos 3 m ',ITOA(X),13"
    }
    WAIT 11
    {
      X = 0
      WHILE (SETTINGS[1][WDR_X_POS] > WDR_X_ZERO )
      {
        SETTINGS[1][WDR_X_POS] = SETTINGS[1][WDR_X_POS]-PIXEL_JUMP
        X = X + 1
      }
      SEND_STRING SuperView,"'pos 1 j ',ITOA(X),13"  
    }
    WAIT 12
    {
      X = 0
      WHILE (SETTINGS[2][WDR_Y_POS] > WDR_Y_ZERO )
      {
        SETTINGS[2][WDR_Y_POS] = SETTINGS[2][WDR_Y_POS]-PIXEL_JUMP
        X = X + 1
      }
      SEND_STRING SuperView,"'pos 2 i ',ITOA(X),13"
    }
    (* LOOP 4 *)
    WAIT 13
    {
      X = 0
      WHILE (SETTINGS[2][WDR_X_POS] < ((TOTAL_WIDTH/2)+WDR_X_ZERO) )
      {
        SETTINGS[2][WDR_X_POS] = SETTINGS[2][WDR_X_POS]+PIXEL_JUMP
        X = X + 1
      }
      SEND_STRING SuperView,"'pos 2 l ',ITOA(X),13"
    }
    WAIT 14
    { 
      X = 0
      WHILE (SETTINGS[4][WDR_Y_POS] < ((TOTAL_HEIGHT/2)+WDR_Y_ZERO) )
      {
        SETTINGS[4][WDR_Y_POS] = SETTINGS[4][WDR_Y_POS]+PIXEL_JUMP
        X = X + 1
      }
      SEND_STRING SuperView,"'pos 4 m ',ITOA(X),13"
    }
    WAIT 15
    {
      X = 0
      WHILE (SETTINGS[3][WDR_X_POS] > WDR_X_ZERO )
      {
        SETTINGS[3][WDR_X_POS] = SETTINGS[3][WDR_X_POS]-PIXEL_JUMP
        X = X + 1
      }
      SEND_STRING SuperView,"'pos 3 j ',ITOA(X),13"  
    }
    WAIT 16
    {
      X = 0
      WHILE (SETTINGS[1][WDR_Y_POS] > WDR_Y_ZERO )
      {
        SETTINGS[1][WDR_Y_POS] = SETTINGS[1][WDR_Y_POS]-PIXEL_JUMP
        X = X + 1
      }
      SEND_STRING SuperView,"'pos 1 i ',ITOA(X),13"
    }
    WAIT 17 CALL 'SVWIN00F' (SuperView,BACKGROUND,"'ON'",0)
  }
(* END MOVEMENT *)
}

DEFINE_CALL 'RUN SV DEMO 4'
{
  PRESET = 4
  CALL 'SVWIN00F' (SuperView,SET_WINDOW_ALL,"'OFF'",0)

  SETTINGS[1][WDR_X_POS] = WDR_X_ZERO - (TOTAL_WIDTH/3)
  SETTINGS[1][WDR_Y_POS] = 50 + WDR_Y_ZERO
  SETTINGS[1][WDR_WIDTH] = TOTAL_WIDTH/3
  SETTINGS[1][WDR_HEIGHT] = TOTAL_HEIGHT/3
  SEND_STRING SuperView,"'wdr 1 -',ITOA(TOTAL_WIDTH/3),' 50 ',ITOA(TOTAL_WIDTH/3),' ',ITOA(TOTAL_HEIGHT/3),13"
 
  SETTINGS[3][WDR_X_POS] = WDR_X_ZERO - (TOTAL_WIDTH/3)
  SETTINGS[3][WDR_Y_POS] = 500
  SETTINGS[3][WDR_WIDTH] = TOTAL_WIDTH/3
  SETTINGS[3][WDR_HEIGHT] = TOTAL_HEIGHT/3
  SEND_STRING SuperView,"'wdr 3 -',ITOA(TOTAL_WIDTH/3),' 500 ',ITOA(TOTAL_WIDTH/3),' ',ITOA(TOTAL_HEIGHT/3),13"

  CALL 'SVWIN00F' (SuperView,SET_WINDOW,"'1 on'",0)
  CALL 'SVWIN00F' (SuperView,SET_WINDOW,"'3 on'",0)

  WAIT 30
  {
  (* MOVEMENT *)
      X = 0
      WHILE (SETTINGS[1][WDR_X_POS] < (TOTAL_WIDTH-100-SETTINGS[1][WDR_WIDTH]+WDR_X_ZERO))
      {
        SETTINGS[1][WDR_X_POS] = SETTINGS[1][WDR_X_POS]+PIXEL_JUMP
        X = X + 1
      } 
    SEND_STRING SuperView,"'pos 1 l ',ITOA(X),13"
  }  
  WAIT 32
  {
    X = 0
    WHILE (SETTINGS[3][WDR_X_POS] < (TOTAL_WIDTH-100-SETTINGS[3][WDR_WIDTH]+WDR_X_ZERO))
    {
      SETTINGS[3][WDR_X_POS] = SETTINGS[3][WDR_X_POS]+PIXEL_JUMP
      X = X + 1
    }
    SEND_STRING SuperView,"'pos 3 l ',ITOA(X),13"
  }
  (* END MOVEMENT *)
}

DEFINE_CALL 'RUN SV DEMO 5'
{
  PRESET = 5
  CALL 'SVWIN00F' (SuperView,SET_WINDOW_ALL,"'OFF'",0)  
  
  SETTINGS[1][WDR_X_POS] = WDR_X_ZERO
  SETTINGS[1][WDR_Y_POS] = WDR_Y_ZERO
  SETTINGS[1][WDR_WIDTH] = SINGLE_WIDTH
  SETTINGS[1][WDR_HEIGHT] = SINGLE_HEIGHT
  CALL 'Setup Coords' (1,0,0,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[2][WDR_X_POS] = WDR_X_ZERO + SINGLE_WIDTH
  SETTINGS[2][WDR_Y_POS] = WDR_Y_ZERO
  SETTINGS[2][WDR_WIDTH] = SINGLE_WIDTH
  SETTINGS[2][WDR_HEIGHT] = SINGLE_HEIGHT
  CALL 'Setup Coords' (2,SINGLE_WIDTH,0,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[3][WDR_X_POS] = WDR_X_ZERO + MAIN_WIDTH
  SETTINGS[3][WDR_Y_POS] = WDR_Y_ZERO
  SETTINGS[3][WDR_WIDTH] = SINGLE_WIDTH
  SETTINGS[3][WDR_HEIGHT] = SINGLE_HEIGHT
  CALL 'Setup Coords' (3,MAIN_WIDTH,0,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[4][WDR_X_POS] = WDR_X_ZERO
  SETTINGS[4][WDR_Y_POS] = WDR_Y_ZERO + (SINGLE_HEIGHT * 2)
  SETTINGS[4][WDR_WIDTH] = SINGLE_WIDTH
  SETTINGS[4][WDR_HEIGHT] = SINGLE_HEIGHT
  CALL 'Setup Coords' (4,0,SINGLE_HEIGHT*2,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[5][WDR_X_POS] = WDR_X_ZERO + SINGLE_WIDTH
  SETTINGS[5][WDR_Y_POS] = WDR_Y_ZERO + (SINGLE_HEIGHT * 2)
  SETTINGS[5][WDR_WIDTH] = SINGLE_WIDTH
  SETTINGS[5][WDR_HEIGHT] = SINGLE_HEIGHT
  CALL 'Setup Coords' (5,SINGLE_WIDTH,SINGLE_HEIGHT*2,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  SETTINGS[6][WDR_X_POS] = WDR_X_ZERO + MAIN_WIDTH
  SETTINGS[6][WDR_Y_POS] = WDR_Y_ZERO + (SINGLE_HEIGHT * 2)
  SETTINGS[6][WDR_WIDTH] = SINGLE_WIDTH
  SETTINGS[6][WDR_HEIGHT] = SINGLE_HEIGHT
  CALL 'Setup Coords' (6,MAIN_WIDTH,SINGLE_HEIGHT*2,SINGLE_WIDTH,SINGLE_HEIGHT,DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)

  CALL 'SVWIN00F' (SuperView,SET_WINDOW_ALL,"'on'",0)
}

DEFINE_CALL 'RUN SV DEMO 6'
{
 (* unused *)
 PRESET = 6
}

DEFINE_CALL 'ZOOM IN' (DEV DEVICE,WIN)
{
   IF (SETTINGS[WIN][WSR_WIDTH] > (PIXEL_JUMP*2) AND 
       SETTINGS[WIN][WSR_HEIGHT] > (PIXEL_JUMP*2))
   {
     SETTINGS[WIN][WSR_WIDTH] = SETTINGS[WIN][WSR_WIDTH]-PIXEL_JUMP
     SETTINGS[WIN][WSR_HEIGHT] = SETTINGS[WIN][WSR_HEIGHT]-PIXEL_JUMP
     CALL 'Setup Coords' (WIN,SETTINGS[WIN][WSR_X_POS],SETTINGS[WIN][WSR_Y_POS],
                              SETTINGS[WIN][WSR_WIDTH],SETTINGS[WIN][WSR_HEIGHT],DATA_STR)
     CALL 'SVWIN00F' (DEVICE,WSR,"DATA_STR",0)
   }
}
DEFINE_CALL 'ZOOM OUT' (DEV DEVICE,WIN)
{
   IF (SETTINGS[WIN][WSR_WIDTH] < SETTINGS[WIN][INPUT_RES_WIDTH] AND 
       SETTINGS[WIN][WSR_HEIGHT] < SETTINGS[WIN][INPUT_RES_HEIGHT])
   {
     SETTINGS[WIN][WSR_WIDTH] = SETTINGS[WIN][WSR_WIDTH]+PIXEL_JUMP
     SETTINGS[WIN][WSR_HEIGHT] = SETTINGS[WIN][WSR_HEIGHT]+PIXEL_JUMP
     CALL 'Setup Coords' (WIN,SETTINGS[WIN][WSR_X_POS],SETTINGS[WIN][WSR_Y_POS],
                              SETTINGS[WIN][WSR_WIDTH],SETTINGS[WIN][WSR_HEIGHT],DATA_STR)
     CALL 'SVWIN00F' (DEVICE,WSR,"DATA_STR",0)
   }
}
DEFINE_CALL 'PAN LEFT' (DEV DEVICE,WIN)
{
   IF (SETTINGS[WIN][WSR_X_POS] > 0)
   {
     SETTINGS[WIN][WSR_X_POS] = SETTINGS[WIN][WSR_X_POS]-PIXEL_JUMP
     CALL 'Setup Coords' (WIN,SETTINGS[WIN][WSR_X_POS],SETTINGS[WIN][WSR_Y_POS],
                              SETTINGS[WIN][WSR_WIDTH],SETTINGS[WIN][WSR_HEIGHT],DATA_STR)
     CALL 'SVWIN00F' (DEVICE,WSR,"DATA_STR",0)
   }
}
DEFINE_CALL 'PAN RIGHT' (DEV DEVICE,WIN)
{
   IF (SETTINGS[WIN][WSR_X_POS] < SETTINGS[WIN][INPUT_RES_WIDTH])
   {
     SETTINGS[WIN][WSR_X_POS] = SETTINGS[WIN][WSR_X_POS]+PIXEL_JUMP
     CALL 'Setup Coords' (WIN,SETTINGS[WIN][WSR_X_POS],SETTINGS[WIN][WSR_Y_POS],
                              SETTINGS[WIN][WSR_WIDTH],SETTINGS[WIN][WSR_HEIGHT],DATA_STR)
     CALL 'SVWIN00F' (DEVICE,WSR,"DATA_STR",0)
   }
}
DEFINE_CALL 'PAN UP' (DEV DEVICE,WIN)
{
   IF (SETTINGS[WIN][WSR_Y_POS] > 0)
   {
     SETTINGS[WIN][WSR_Y_POS] = SETTINGS[WIN][WSR_Y_POS]-PIXEL_JUMP
     CALL 'Setup Coords' (WIN,SETTINGS[WIN][WSR_X_POS],SETTINGS[WIN][WSR_Y_POS],
                              SETTINGS[WIN][WSR_WIDTH],SETTINGS[WIN][WSR_HEIGHT],DATA_STR)
     CALL 'SVWIN00F' (DEVICE,WSR,"DATA_STR",0)
   }
}
DEFINE_CALL 'PAN DOWN' (DEV DEVICE,WIN)
{
   IF (SETTINGS[WIN][WSR_X_POS] < SETTINGS[WIN][INPUT_RES_WIDTH])
   {
     SETTINGS[WIN][WSR_Y_POS] = SETTINGS[WIN][WSR_Y_POS]+PIXEL_JUMP
     CALL 'Setup Coords' (WIN,SETTINGS[WIN][WSR_X_POS],SETTINGS[WIN][WSR_Y_POS],
                              SETTINGS[WIN][WSR_WIDTH],SETTINGS[WIN][WSR_HEIGHT],DATA_STR)
     CALL 'SVWIN00F' (DEVICE,WSR,"DATA_STR",0)
   }
}
DEFINE_CALL 'SLIDE WINDOW LEFT' (DEV DEVICE,WIN) (* MOVE WINDOW LEFT *)
{
  IF (SETTINGS[WIN][WDR_X_POS] > (WDR_X_ZERO - SETTINGS[WIN][WDR_WIDTH]))  
  {
         SETTINGS[WIN][WDR_X_POS] = SETTINGS[WIN][WDR_X_POS]-(PIXEL_JUMP)
         CALL 'SVWIN00F' (DEVICE,POS,"ITOA(WIN),' j 1'",0)
  }
}
DEFINE_CALL 'SLIDE WINDOW RIGHT' (DEV DEVICE,WIN) (* MOVE WINDOW RIGHT *)
{
  IF (SETTINGS[WIN][WDR_X_POS] < (WDR_X_ZERO + TOTAL_WIDTH))
  {
       SETTINGS[WIN][WDR_X_POS] = SETTINGS[WIN][WDR_X_POS]+(PIXEL_JUMP)
       CALL 'SVWIN00F' (DEVICE,POS,"ITOA(WIN),' l 1'",0)
  }
}
DEFINE_CALL 'SLIDE WINDOW UP' (DEV DEVICE,WIN) (* MOVE WINDOW UP *)
{
  IF (SETTINGS[WIN][WDR_Y_POS] > (WDR_Y_ZERO - SETTINGS[WIN][WDR_HEIGHT]))
  {
       SETTINGS[WINDOW][WDR_Y_POS] = SETTINGS[WIN][WDR_Y_POS]-PIXEL_JUMP
       CALL 'SVWIN00F' (DEVICE,POS,"ITOA(WIN),' i 1'",0)
  }
}
DEFINE_CALL 'SLIDE WINDOW DOWN' (DEV DEVICE,WIN) (* MOVE WINDOW DOWN *)
{
  IF (SETTINGS[WIN][WDR_Y_POS] < (WDR_Y_ZERO + TOTAL_HEIGHT))
  {
       SETTINGS[WINDOW][WDR_Y_POS] = SETTINGS[WIN][WDR_Y_POS]+PIXEL_JUMP
       CALL 'SVWIN00F' (DEVICE,POS,"ITOA(WIN),' m 1'",0)
  }
}
DEFINE_CALL 'RESIZE BIGGER 4TO3' (DEV DEVICE, WIN)
{
  SETTINGS[WIN][WDR_WIDTH]  = SETTINGS[WIN][WDR_WIDTH]+PIXEL_JUMP 
  SETTINGS[WIN][WDR_HEIGHT] = ((SETTINGS[WIN][WDR_WIDTH] * 3) / 4)
  CALL 'Setup WDR Coords' (WIN,SETTINGS[WIN][WDR_X_POS],SETTINGS[WIN][WDR_Y_POS],
                               SETTINGS[WIN][WDR_WIDTH],SETTINGS[WIN][WDR_HEIGHT],DATA_STR)
  CALL 'SVWIN00F' (DEVICE,WDR,"DATA_STR",0)
}
DEFINE_CALL 'RESIZE SMALLER 4TO3' (DEV DEVICE, WIN)
{
  SETTINGS[WIN][WDR_WIDTH]  = SETTINGS[WIN][WDR_WIDTH]-PIXEL_JUMP 
  SETTINGS[WIN][WDR_HEIGHT] = ((SETTINGS[WIN][WDR_WIDTH] * 3) / 4)
  CALL 'Setup WDR Coords' (WIN,SETTINGS[WIN][WDR_X_POS],SETTINGS[WIN][WDR_Y_POS],
                               SETTINGS[WIN][WDR_WIDTH],SETTINGS[WIN][WDR_HEIGHT],DATA_STR)
  CALL 'SVWIN00F' (DEVICE,WDR,"DATA_STR",0)
}
DEFINE_CALL 'RESIZE BIGGER 16TO9' (DEV DEVICE, WIN)
{
  SETTINGS[WIN][WDR_WIDTH]  = SETTINGS[WIN][WDR_WIDTH]+PIXEL_JUMP 
  SETTINGS[WIN][WDR_HEIGHT] = ((SETTINGS[WIN][WDR_WIDTH] * 9) / 16)
  CALL 'Setup WDR Coords' (WIN,SETTINGS[WIN][WDR_X_POS],SETTINGS[WIN][WDR_Y_POS],
                               SETTINGS[WIN][WDR_WIDTH],SETTINGS[WIN][WDR_HEIGHT],DATA_STR)
  CALL 'SVWIN00F' (DEVICE,WDR,"DATA_STR",0)
}
DEFINE_CALL 'RESIZE SMALLER 16TO9' (DEV DEVICE, WIN)
{
  SETTINGS[WIN][WDR_WIDTH]  = SETTINGS[WIN][WDR_WIDTH]-PIXEL_JUMP 
  SETTINGS[WIN][WDR_HEIGHT] = ((SETTINGS[WIN][WDR_WIDTH] * 9) / 16)
  CALL 'Setup WDR Coords' (WIN,SETTINGS[WIN][WDR_X_POS],SETTINGS[WIN][WDR_Y_POS],
                               SETTINGS[WIN][WDR_WIDTH],SETTINGS[WIN][WDR_HEIGHT],DATA_STR)
  CALL 'SVWIN00F' (DEVICE,WDR,"DATA_STR",0)
}
DEFINE_CALL 'PROCESS TP BUFFER' (BUFFER[255])
LOCAL_VAR
        PAGE[100]
{
    SELECT
    {   
        ACTIVE (FIND_STRING(BUFFER,'KEYB-',1)) :    (* KEYBOARD STRING *)
        {
            TRASH = REMOVE_STRING(BUFFER,'KEYB-',1)
            NAME   = BUFFER
        }
        ACTIVE (FIND_STRING(BUFFER,'KEYP-',1)) :    (* KEYPAD STRING *)
        {
            TRASH = REMOVE_STRING(BUFFER,'KEYP-',1)
            NUM   = BUFFER
        }        
        ACTIVE (FIND_STRING(BUFFER,'PAGE-',1)) :    (* PAGE FLIP STRING *)
        {
            TRASH = REMOVE_STRING(BUFFER,'PAGE-',1)
            PAGE   = BUFFER                          (* CURRENT PAGE *)
        }        
    }
  SEND_COMMAND TP,"'!T',14,NUM"
  SEND_COMMAND TP,"'!T',15,NAME"
  CLEAR_BUFFER TP_BUFFER
}
(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

SEND_COMMAND SuperView,'SET BAUD 9600,N,8,1'
SEND_COMMAND TP,'TPAGEON'       (* ENABLE PAGE TRACKING *)

CREATE_BUFFER SuperView,SV_BUFFER (* READ MESSAGE FROM SUPERVIEW *)
CREATE_BUFFER TP,TP_BUFFER      (* READ MESSAGES FROM TP *)

CREATE_LEVEL TP,1,X_LEVEL
CREATE_LEVEL TP,2,Y_LEVEL
CREATE_LEVEL TP,3,INPUT_LEVEL_GRAPH
CREATE_LEVEL TP,4,OUTPUT_GAMMA_GRAPH

(* INITIALIZE THE TOUCH PANEL & STARTUP VALUES *)
WAIT 10
{
  STEP       = 0
  WINDOW     = 0
  SETTINGS[OUTPUT][TESTPATTERN] = NOPATTERN
  PIXEL_JUMP = 35
  CALL 'SVWIN00F' (SuperView,HOST,"",0)
  SEND_COMMAND TP,'PAGE-Main Page'
}
(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

PUSH[TP,17]                        (* LOGO/INIT PROCEDURE *)
{
  (* Get Resolution *)
  CALL 'SVWIN00F' (SuperView,SETRATE,"ITOA(PIXEL_JUMP),' ',ITOA(PIXEL_JUMP)",0)
  CALL 'SVWIN00F' (SuperView,ECHO,'ON',0)
  WINDOW = 0
  CLEAR_BUFFER SV_BUFFER
  CALL 'SVWIN00F' (SuperView,HOST,"",0)
  ACTION = HOST_LIST
  WAIT 15
  {
    WINDOW = 1
    ACTION = SETUP
    WAIT 21
    {
      WINDOW = 2
      ACTION = SETUP
      WAIT 21
      {
        WINDOW = 3
        ACTION = SETUP
        WAIT 21
        {
          WINDOW = 4
          ACTION = SETUP
          WAIT 21
          {
            WINDOW = 5
            ACTION = SETUP
            WAIT 21
            {
              WINDOW = 6
              ACTION = SETUP
              WAIT 20 SEND_COMMAND TP,'PAGE-new main'  
              WAIT 21 CALL 'SVWIN00F' (SuperView,ECHO,'OFF',0)
              WAIT 21 WINDOW = 0
            }
          }
        }
      }
    }  
  }
}

(* Initialize the SuperView settings *)
SELECT 
{
   ACTIVE (WINDOW && ACTION = SETUP) :
   {
      ACTION = 0
      CALL 'SVWIN00F' (SuperView,WDR,"ITOA(WINDOW)",0)
      CALL 'SVWIN00F' (SuperView,WSR,"ITOA(WINDOW)",0)
      CALL 'SVWIN00F' (SuperView,BRIGHT,"ITOA(WINDOW)",0)
      CALL 'SVWIN00F' (SuperView,CONTRAST,"ITOA(WINDOW)",0)
      CALL 'SVWIN00F' (SuperView,SATURATION,"ITOA(WINDOW)",0)
      CALL 'SVWIN00F' (SuperView,HUE,"ITOA(WINDOW)",0)
      CALL 'SVWIN00F' (SuperView,SHARPNESS,"ITOA(WINDOW)",0)
      CALL 'SVWIN00F' (SuperView,INTYPE,"ITOA(WINDOW)",0)
      
      WAIT 10 (* READ IN WDR VALUES *)
      {
       X = FIND_STRING(SV_BUFFER,'WDR',1)      
       IF (X)
       {
        SV_STRING = MID_STRING(SV_BUFFER,X+5,30)
        STR = REMOVE_STRING(SV_STRING,' ',1)
        X = FIND_STRING(STR,'-',1)
        IF (X)
        {
          TRASH = REMOVE_STRING(STR,'-',1)
          SETTINGS[WINDOW][WDR_X_POS]  = WDR_X_ZERO - ATOI(STR)
        }
        ELSE
          SETTINGS[WINDOW][WDR_X_POS]  = ATOI(STR) + WDR_X_ZERO
        STR = REMOVE_STRING(SV_STRING,' ',1)
        X = FIND_STRING(STR,'-',1)
        IF (X)
        {
          TRASH = REMOVE_STRING(STR,'-',1)
          SETTINGS[WINDOW][WDR_Y_POS]  = WDR_Y_ZERO - ATOI(STR)
        }
        ELSE
          SETTINGS[WINDOW][WDR_Y_POS] = ATOI(STR) + WDR_Y_ZERO

        STR = REMOVE_STRING(SV_STRING,' ',1)
        SETTINGS[WINDOW][WDR_WIDTH]  = ATOI(STR)
        STR = REMOVE_STRING(SV_STRING,' ',1)
        SETTINGS[WINDOW][WDR_HEIGHT] = ATOI(STR)
       }
       (* READ IN WSR VALUES *)
       X = FIND_STRING(SV_BUFFER,'WSR',1)
       IF (X)
       {
        SV_STRING = MID_STRING(SV_BUFFER,X+5,30)

        STR = REMOVE_STRING(SV_STRING,' ',1)
        SETTINGS[WINDOW][WSR_X_POS] = ATOI(STR)
        STR = REMOVE_STRING(SV_STRING,' ',1)
        SETTINGS[WINDOW][WSR_Y_POS] = ATOI(STR)
        STR = REMOVE_STRING(SV_STRING,' ',1)
        SETTINGS[WINDOW][WSR_WIDTH]   = ATOI(STR)
        STR = REMOVE_STRING(SV_STRING,' ',1)
        SETTINGS[WINDOW][WSR_HEIGHT]  = ATOI(STR)
       }
       (* READ IN BRIGHTNESS VALUES *)
       X = FIND_STRING(SV_BUFFER,'bri',1)
       IF (X)
       {
        SV_STRING = MID_STRING(SV_BUFFER,X+5,30)

        STR = REMOVE_STRING(SV_STRING,'>',1)
        X = FIND_STRING(STR,'-',1)
        IF (X)
        {
          TRASH = REMOVE_STRING(STR,'-',1)
          SETTINGS[WINDOW][BRIGHT]  = 510 - ATOI(STR)
        }
        ELSE
          SETTINGS[WINDOW][BRIGHT]  = ATOI(STR) + 510
       }
       (* READ IN CONTRAST VALUES *)
       X = FIND_STRING(SV_BUFFER,'cont',1)
       IF (X)
       {
        SV_STRING = MID_STRING(SV_BUFFER,X+6,30)
        STR = REMOVE_STRING(SV_STRING,'>',1)
        SETTINGS[WINDOW][CONTRAST] = ATOI(STR)
       }
       (* READ IN SATURATION VALUES *)
       X = FIND_STRING(SV_BUFFER,'sat',1)
       IF (X)
       {
        SV_STRING = MID_STRING(SV_BUFFER,X+5,30)
        STR = REMOVE_STRING(SV_STRING,'>',1)
        SETTINGS[WINDOW][SATURATION] = ATOI(STR)
       }
       (* READ IN HUE VALUES *)
       X = FIND_STRING(SV_BUFFER,'hue',1)
       IF (X)
       {
        SV_STRING = MID_STRING(SV_BUFFER,X+5,30)
        STR = REMOVE_STRING(SV_STRING,'>',1)
        SETTINGS[WINDOW][HUE] = ATOI(STR)
       }
       (* READ IN SHARPNESS VALUES *)
       X = FIND_STRING(SV_BUFFER,'sharp',1)
       IF (X)
       {
        SV_STRING = MID_STRING(SV_BUFFER,X+7,30)
        STR = REMOVE_STRING(SV_STRING,'>',1)
        SETTINGS[WINDOW][SHARPNESS] = ATOI(STR)
       }
       SELECT                 (* READ IN INPUT TYPE *)
       {
         ACTIVE (FIND_STRING(SV_BUFFER,'SVIDEO',1)) :
           SETTINGS[WINDOW][INTYPE] = SVIDEO
         ACTIVE (FIND_STRING(SV_BUFFER,'COMPOSITE',1)) :
           SETTINGS[WINDOW][INTYPE] = COMPOSITE
         ACTIVE (FIND_STRING(SV_BUFFER,'RGB',1)) :
           SETTINGS[WINDOW][INTYPE] = RGB          
         ACTIVE(1) :
           SETTINGS[WINDOW][INTYPE] = ERROR
       }
      CLEAR_BUFFER SV_BUFFER
      CALL 'SVWIN00F' (SuperView,ECHO,'ON',0) (* SV BUFFER DOESN'T WORK RIGHT IF IT IS EMPTY *)
      CALL 'SVWIN00F' (SuperView,RGB_INPUT,"ITOA(WINDOW)",0)
      ACTION = RGB_INPUT
      }
   }
   ACTIVE (ACTION = RGB_INPUT) :
   {
     WAIT 5
     {     (* READ IN INPUT RESOLUTION *)
           IF (FIND_STRING(SV_BUFFER,'HFREQ',1))
           {
             SV_STRING = SV_BUFFER
             REMOVE_STRING(SV_STRING, 'IL', 1)
             SETTINGS[WINDOW][INPUT_RES_WIDTH] = ATOI(MID_STRING(SV_STRING,34,5))
             SETTINGS[WINDOW][INPUT_RES_HEIGHT] = ATOI(MID_STRING(SV_STRING,49,20))
           }
           ELSE
           {
              SETTINGS[WINDOW][INPUT_RES_WIDTH]  = 0
              SETTINGS[WINDOW][INPUT_RES_HEIGHT] = 0
           }
           ACTION = 0
           CLEAR_BUFFER SV_BUFFER
           CALL 'SVWIN00F' (SuperView,ECHO,'ON',0)
     }
   }
   ACTIVE (ACTION = HOST_LIST) :
   {
     WAIT 5
     {     (* READ IN OUTPUT RESOLUTION *)
      IF (FIND_STRING(SV_BUFFER,'HFREQ',1))
      {
        SV_STRING = SV_BUFFER
        REMOVE_STRING(SV_STRING, 'IL', 1)
        
        TOTAL_WIDTH  = ATOI(MID_STRING(SV_STRING,34,5))
        TOTAL_HEIGHT = ATOI(MID_STRING(SV_STRING,49,5))

        SETTINGS[OUTPUT][OUTPUT_RES_WIDTH]  = TOTAL_WIDTH
        SETTINGS[OUTPUT][OUTPUT_RES_HEIGHT] = TOTAL_HEIGHT
        
        STR = "ITOA(SETTINGS[OUTPUT][OUTPUT_RES_WIDTH]), 'X', ITOA(SETTINGS[OUTPUT][OUTPUT_RES_HEIGHT])"
        SEND_COMMAND TP,"'!T',1,STR"
        
        SINGLE_WIDTH = TOTAL_WIDTH / (TOTAL_WINDOWS - 1)
        SINGLE_HEIGHT= TOTAL_HEIGHT/ (TOTAL_WINDOWS - 1)
        
        MAIN_WIDTH   = TOTAL_WIDTH  - SINGLE_WIDTH
        MAIN_HEIGHT  = TOTAL_HEIGHT - SINGLE_HEIGHT
        
        WDR_X_ZERO = TOTAL_WIDTH * (MULTIPLIER/2)
        WDR_Y_ZERO = TOTAL_HEIGHT * (MULTIPLIER/2)
        ACTION = 0
        CLEAR_BUFFER SV_BUFFER
        CALL 'SVWIN00F' (SuperView,ECHO,'ON',0)
      }
     }
   }
   ACTIVE (1) :
   {
      IF (FIND_STRING(UPPER_STRING(SV_STRING),'ERROR',1))
      {
        SEND_COMMAND TP,"'!T',1,'Error with Initialization'"
      }
   }
}

(* USED FOR THE AUTOMATED DEMONSTRATION MODE *)
IF (STEP)
{
  WAIT 100
  {
    SELECT
    {
      ACTIVE (STEP = SV_DEMO_1) :
      {
        STEP = SV_DEMO_2
        CALL 'RUN SV DEMO 1'
      }
      ACTIVE (STEP = SV_DEMO_2) :
      {
        STEP = SV_DEMO_3
        CALL 'RUN SV DEMO 2'
      }
      ACTIVE (STEP = SV_DEMO_3) :
      {
        STEP = SV_DEMO_4
        CALL 'RUN SV DEMO 3'
      }
      ACTIVE (STEP = SV_DEMO_4) :
      {
        STEP = SV_DEMO_5
        CALL 'RUN SV DEMO 4'
      }
      ACTIVE (STEP = SV_DEMO_5) :
      {
        STEP = SV_DEMO_1
        CALL 'RUN SV DEMO 5'
      }
      ACTIVE (1) :
      {
        STEP = 0
      }
    }
  }
}

(* Select Window *)

PUSH[TP,1]                         (* Window 1 *)
  WINDOW = 1
PUSH[TP,2]                         (* Window 2 *)
  WINDOW = 2
PUSH[TP,3]                         (* Window 3 *)
  WINDOW = 3
PUSH[TP,4]                         (* Window 4 *)
  WINDOW = 4
PUSH[TP,5]                         (* Window 5 *)
  WINDOW = 5
PUSH[TP,6]                         (* Window 6 *)
  WINDOW = 6
PUSH[TP,7]                         (* Window 7 *)
  WINDOW = 7
PUSH[TP,8]                         (* Window 8 *)
  WINDOW = 8
PUSH[TP,9]                         (* Window 9 *)
  WINDOW = 9
PUSH[TP,10]                        (* Window 10 *)
  WINDOW = 10
PUSH[TP,11]                        (* Window 11 *)
  WINDOW = 11
PUSH[TP,12]                        (* Window 12 *)
  WINDOW = 12
  
PUSH[TP,1]
PUSH[TP,2]
PUSH[TP,3]
PUSH[TP,4]
PUSH[TP,5]
PUSH[TP,6]
PUSH[TP,7]
PUSH[TP,8]
PUSH[TP,9]
PUSH[TP,10]
PUSH[TP,11]
PUSH[TP,12]
{
(* TURNS THE WINDOW ON, REPORTS ALL THE INPUT SETTINGS TO THE TOUCH PANEL *)
  CALL 'SVWIN00F' (SuperView,SET_WINDOW,"ITOA(WINDOW),' ON'",0)
  IF (SETTINGS[WINDOW][INTYPE] = RGB)
    STR = "ITOA(SETTINGS[WINDOW][INPUT_RES_WIDTH]),' X ',ITOA(SETTINGS[WINDOW][INPUT_RES_HEIGHT])"
  ELSE IF (SETTINGS[WINDOW][INTYPE] = SVIDEO OR SETTINGS[WINDOW][INTYPE] = COMPOSITE)
    STR = "'VIDEO'"
  ELSE
    STR = "'ERROR'"
  SEND_COMMAND TP,"'!T',2,STR"
  CALL 'REPORT BRIGHTNESS' (SuperView, WINDOW)
  STR = "ITOA(SETTINGS[WINDOW][CONTRAST])"
  SEND_COMMAND TP,"'!T',4,STR"
  STR = "ITOA(SETTINGS[WINDOW][SHARPNESS])"
  SEND_COMMAND TP,"'!T',5,STR"
  STR = "ITOA(SETTINGS[WINDOW][HUE])"
  SEND_COMMAND TP,"'!T',6,STR"
  STR = "ITOA(SETTINGS[WINDOW][SATURATION])"
  SEND_COMMAND TP,"'!T',7,STR"
  CALL 'Negative WDR Converter' (WDR_X_ZERO, WDR_Y_ZERO,
                                 SETTINGS[WINDOW][WDR_X_POS],
                                 SETTINGS[WINDOW][WDR_Y_POS])
  STR = "NEW_X,',',NEW_Y"
  SEND_COMMAND TP,"'!T',10,STR"
  STR = "ITOA(SETTINGS[WINDOW][WDR_WIDTH]),' X ',ITOA(SETTINGS[WINDOW][WDR_HEIGHT])"
  SEND_COMMAND TP,"'!T',11,STR"
  STR = "ITOA(SETTINGS[WINDOW][WSR_X_POS]),',',ITOA(SETTINGS[WINDOW][WSR_Y_POS]),',',
         ITOA(SETTINGS[WINDOW][WSR_WIDTH]),',',ITOA(SETTINGS[WINDOW][WSR_HEIGHT])"    
  SEND_COMMAND TP,"'!T',13,STR"
}
[TP,1]  = (WINDOW = 1)
[TP,2]  = (WINDOW = 2)
[TP,3]  = (WINDOW = 3)
[TP,4]  = (WINDOW = 4)
[TP,5]  = (WINDOW = 5)
[TP,6]  = (WINDOW = 6)
[TP,7]  = (WINDOW = 7)
[TP,8]  = (WINDOW = 8)
[TP,9]  = (WINDOW = 9)
[TP,10] = (WINDOW = 10)
[TP,11] = (WINDOW = 11)
[TP,12] = (WINDOW = 12)

PUSH[TP,19]                         (* Input Interactive Adjust *)
{
  MENU = RGB_INPUT_INTERACTIVE
  CALL 'SVWIN00F' (SuperView,RGB_INPUT_INTERACTIVE,"ITOA(WINDOW)",0)
}
[TP,19] = (MENU = RGB_INPUT_INTERACTIVE)
PUSH[TP,20]                         (* Host Interactive Adjust *)
{
  MENU = HOST_INTERACTIVE
  CALL 'SVWIN00F' (SuperView,HOST_INTERACTIVE,"",0)
}
[TP,20] = (MENU = HOST_INTERACTIVE)

PUSH[TP,21]                         (* Upper Corner Left *)
  SEND_STRING SuperView,"'j',0"
PUSH[TP,22]                         (* Upper Corner Right *)
  SEND_STRING SuperView,"'l',0"
PUSH[TP,23]                         (* Upper Corner Up *)
  SEND_STRING SuperView,"'i',0"
PUSH[TP,24]                         (* Upper Corner Down *)
  SEND_STRING SuperView,"'m',0"
PUSH[TP,25]                         (* Lower Corner Left *)
  SEND_STRING SuperView,"'J',0"
PUSH[TP,26]                         (* Lower Corner Right *)
  SEND_STRING SuperView,"'L',0"
PUSH[TP,27]                         (* Lower Corner Up *)
  SEND_STRING SuperView,"'I',0"
PUSH[TP,28]                         (* Lower Corner Down *)
  SEND_STRING SuperView,"'M',0"
PUSH[TP,29]                         (* Save Changes *)
  SEND_STRING SuperView,"'q',13"

PUSH[TP,30]                         (* Enter Host/Input Number *)
{
  SEND_COMMAND TP,'AKEYP-'

}
PUSH[TP,31]                         (* Enter Host/Input Name *)
{
  SEND_COMMAND TP,'AKEYB-'
}
PUSH[TP,32]                         (* Save Host *)
{
  IF (MENU = RGB_INPUT_INTERACTIVE)
  {
    SEND_STRING SuperView,"'inputname ',ITOA(WINDOW),' ',NAME,13"
    SEND_STRING SuperView,"'inputsave ',ITOA(WINDOW),' ',NUM,13"
    SEND_STRING SuperView,"'y',13"     
  }
  ELSE
  IF (MENU = HOST_INTERACTIVE)
  {
    SEND_STRING SuperView,"'hostname ',NAME,13"
    SEND_STRING SuperView,"'hostsave ',NUM,13"
    SEND_STRING SuperView,"'y',13"     
  }
}
PUSH[TP,33]                         (* Host/Input Number, channel 14 *)
PUSH[TP,34]                         (* Host/Input Name, channel 15 *)
PUSH[TP,35]                         (* Interactive Adjust Background *)
{}
[TP,30] = (MENU = RGB_INPUT_INTERACTIVE)
[TP,31] = (MENU = RGB_INPUT_INTERACTIVE)
[TP,32] = (MENU = RGB_INPUT_INTERACTIVE)
[TP,33] = (MENU = RGB_INPUT_INTERACTIVE)
[TP,34] = (MENU = RGB_INPUT_INTERACTIVE)
[TP,35] = (MENU = RGB_INPUT_INTERACTIVE)


(*********** BEGIN INPUT CONTROLS ***********)
PUSH[TP,39]                         (* Input Levels from Popup *)
  ACTION = BRIGHT
PUSH[TP,40]                         (* Brightness *)
  ACTION = BRIGHT
[TP,40] = (ACTION = BRIGHT)
PUSH[TP,41]                         (* Contrast *)
  ACTION = CONTRAST
[TP,41] = (ACTION = CONTRAST)
PUSH[TP,42]                         (* Sharpness *)
  ACTION = SHARPNESS
[TP,42] = (ACTION = SHARPNESS)
PUSH[TP,43]                         (* Hue *)
  ACTION = HUE
[TP,43] = (ACTION = HUE)
PUSH[TP,44]                         (* Saturation *)
  ACTION = SATURATION
[TP,44] = (ACTION = SATURATION)
PUSH[TP,45]                         (* Overscan *)
{
  ACTION = OVERSCAN
  IF (SETTINGS[WINDOW][OVERSCAN] = TRUE)
  {
     SETTINGS[WINDOW][OVERSCAN] = FALSE
     CALL 'SVWIN00F' (SuperView,OVERSCAN,"ITOA(WINDOW),' ','OFF'",0)
     SEND_COMMAND TP,"'!T',8,'OFF'"
  }
  ELSE
  {
     SETTINGS[WINDOW][OVERSCAN] = TRUE
     CALL 'SVWIN00F' (SuperView,OVERSCAN,"ITOA(WINDOW),' ','ON'",0)
     SEND_COMMAND TP,"'!T',8,'ON'"
  }
  PULSE[TP,45]
}
  
RELEASE[TP,46]                      (* Bar Graph for Input Levels *)
{
  X = INPUT_LEVEL_GRAPH
  IF (ACTION = BRIGHT)
     SETTINGS[WINDOW][ACTION] = X * 4
  ELSE
     SETTINGS[WINDOW][ACTION] = X
}
[TP,46] = (SETTINGS[WINDOW][ACTION] = X)

PUSH[TP,47]                         (* Subtract from Input Level by One *)
{
  PULSE[TP,47]  
  SETTINGS[WINDOW][ACTION] = SETTINGS[WINDOW][ACTION] - 1
}
PUSH[TP,48]                         (* Add to Input Level by One *)
{  
  PULSE[TP,48]
  SETTINGS[WINDOW][ACTION] = SETTINGS[WINDOW][ACTION] + 1
}

RELEASE[TP,46]
PUSH[TP,47]
PUSH[TP,48]
{  
  IF (ACTION = BRIGHT)
  {
     CALL 'REPORT BRIGHTNESS' (SuperView, WINDOW)
  }
  ELSE IF (ACTION = CONTRAST)
  {
     CALL 'SVWIN00F' (SuperView,CONTRAST,"ITOA(WINDOW),' ',ITOA(SETTINGS[WINDOW][ACTION])",0)
     SEND_COMMAND TP,"'!T',4,ITOA(SETTINGS[WINDOW][ACTION])"
  }
  ELSE IF (ACTION = SHARPNESS)
  {
     CALL 'SVWIN00F' (SuperView,SHARPNESS,"ITOA(WINDOW),' ',ITOA(SETTINGS[WINDOW][ACTION])",0)
     SEND_COMMAND TP,"'!T',5,ITOA(SETTINGS[WINDOW][ACTION])"
  }
  ELSE IF (ACTION = HUE)
  {
     CALL 'SVWIN00F' (SuperView,HUE,"ITOA(WINDOW),' ',ITOA(SETTINGS[WINDOW][ACTION])",0)
     SEND_COMMAND TP,"'!T',6,ITOA(SETTINGS[WINDOW][ACTION])"
  }
  ELSE IF (ACTION = SATURATION)
  {
     CALL 'SVWIN00F' (SuperView,SATURATION,"ITOA(WINDOW),' ',ITOA(SETTINGS[WINDOW][ACTION])",0)
     SEND_COMMAND TP,"'!T',7,ITOA(SETTINGS[WINDOW][ACTION])"
  }
}

PUSH[TP,50]                         (* Reset Window *)
{
  CALL 'SVWIN00F' (SuperView,RSR,"ITOA(WINDOW)",0)
  IF (SETTINGS[WINDOW][INTYPE] = RGB)
    SETTINGS[WINDOW][CONTRAST] = 100
  ELSE
    SETTINGS[WINDOW][CONTRAST] = 85
  
  SETTINGS[WINDOW][BRIGHT] = 0
  SETTINGS[WINDOW][SATURATION] = 100
  SETTINGS[WINDOW][SHARPNESS] = 2
  SETTINGS[WINDOW][HUE] = 0
  SETTINGS[WINDOW][OVERSCAN] = FALSE
  SETTINGS[WINDOW][WSR_X_POS] = 0
  SETTINGS[WINDOW][WSR_Y_POS] = 0
  SETTINGS[WINDOW][WSR_WIDTH] = SETTINGS[WINDOW][INPUT_RES_WIDTH]
  SETTINGS[WINDOW][WSR_HEIGHT] = SETTINGS[WINDOW][INPUT_RES_HEIGHT]
}
[TP,50] = (ACTION = RSR)
PUSH[TP,51]                         (* Input Type RGBHV *)
  CALL 'SVWIN00F' (SuperView,INTYPE,"ITOA(WINDOW),' RGB'",0)
[TP,51] = (SETTINGS[WINDOW][INTYPE] = RGB)
PUSH[TP,52]                         (* Input Type Y/C *)
  CALL 'SVWIN00F' (SuperView,INTYPE,"ITOA(WINDOW),' SVIDEO'",0)
[TP,52] = (SETTINGS[WINDOW][INTYPE] = SVIDEO)
PUSH[TP,53]                         (* Input Type Composite *)
  CALL 'SVWIN00F' (SuperView,INTYPE,"ITOA(WINDOW),' COMPOSITE'",0)
[TP,53] = (SETTINGS[WINDOW][INTYPE] = COMPOSITE)
(* END INPUT CONTROLS *)

(* BEGIN OUTPUT CONTROLS *)
RELEASE[TP,55]                      (* Bar Graph for Input Levels *)
{
  X = OUTPUT_GAMMA_GRAPH
  SETTINGS[1][GAMMA] = X
}
[TP,55] = (SETTINGS[1][GAMMA] = X)
PUSH[TP,56]                         (* Subtract from Input Level by One *)
{
  PULSE[TP,56]
  SETTINGS[1][GAMMA] = SETTINGS[1][GAMMA] - 1
}

PUSH[TP,57]                         (* Add to Input Level by One *)
{
  PULSE[TP,57]  
  SETTINGS[1][GAMMA] = SETTINGS[1][GAMMA] + 1
}

RELEASE[TP,55]
PUSH[TP,56]
PUSH[TP,57]
{
  Y = SETTINGS[1][GAMMA] % 100
  X = SETTINGS[1][GAMMA] / 100
  STR = "ITOA(X),'.',ITOA(Y)"
  CALL 'SVWIN00F' (SuperView,GAMMA,"STR",0)
  SEND_COMMAND TP,"'!T',9,STR"
}

PUSH[TP,58]                         (* Background on *)
{
  SETTINGS[WINDOW][BACKGROUND] = TRUE
  CALL 'SVWIN00F' (SuperView,BACKGROUND,"'ON'",0)
  OFF[TP,59]
  ON[TP,58]
}
[TP,58] = (SETTINGS[WINDOW][BACKGROUND] = TRUE)
PUSH[TP,59]                        (* Background off *)
{
  SETTINGS[WINDOW][BACKGROUND] = FALSE
  CALL 'SVWIN00F' (SuperView,BACKGROUND,"'OFF'",0)
  OFF[TP,58]
  ON[TP,59]
}

PUSH[TP,60]                         (* Host Free Run *)
{
  ON[TP,60]
  OFF[TP,61]
  CALL 'SVWIN00F' (SuperView,HOST,"'free'",0)
  SETTINGS[1][HOST] = FREE
}
PUSH[TP,61]                         (* Host Auto Sync *)
{  
  ON[TP,61]
  OFF[TP,60]
  CALL 'SVWIN00F' (SuperView,HOST,"'auto'",0)
  SETTINGS[1][HOST] = AUTO
}

(*********** BEGIN WINDOW MENU ***********)
PUSH[TP,64]                         (* Move/Resize Menu *)
  MENU = MOVE

PUSH[TP,65]                         (* Identify Window *)
{
  PULSE[TP,65]
  CALL 'SVWIN00F' (SuperView,WIN_ID,"ITOA(WINDOW)",0)
}

PUSH[TP,66]                         (* Move Window Button *)
  MENU = MOVE
[TP,66] = (MENU = MOVE)
PUSH[TP,67]                         (* Resize Window Button *)
  MENU = RESIZE
[TP,67] = (MENU = RESIZE)

(* Button choices for moving/resizing window *)
PUSH[TP,68]                         (* Left *)
{
  PULSE[TP,68]
  IF (MENU = MOVE)
    CALL 'SLIDE WINDOW LEFT' (SuperView,WINDOW)
  ELSE IF (MENU = RESIZE)
    CALL 'RESIZE SMALLER 4TO3' (SuperView,WINDOW)
}
PUSH[TP,69]                         (* Right *)
{
  PULSE[TP,69]
  IF (MENU = MOVE)
    CALL 'SLIDE WINDOW RIGHT' (SuperView,WINDOW)
  ELSE IF (MENU = RESIZE)
    CALL 'RESIZE BIGGER 4TO3' (SuperView,WINDOW)
}
PUSH[TP,70]                         (* Up *)
{
  PULSE[TP,70]
  IF (MENU = MOVE)
    CALL 'SLIDE WINDOW UP' (SuperView,WINDOW)
  ELSE IF (MENU = RESIZE)
    CALL 'RESIZE BIGGER 16TO9' (SuperView,WINDOW)
}
PUSH[TP,71]                         (* Down *)
{
  PULSE[TP,71]
  IF (MENU = MOVE)
    CALL 'SLIDE WINDOW DOWN' (SuperView,WINDOW)
  ELSE IF (MENU = RESIZE)
    CALL 'RESIZE SMALLER 16TO9' (SuperView,WINDOW)
}
PUSH[TP,68]
PUSH[TP,69]
PUSH[TP,70]
PUSH[TP,71]
{
  CALL 'Negative WDR Converter' (SETTINGS[OUTPUT][OUTPUT_RES_WIDTH] * (MULTIPLIER/2),
                                 SETTINGS[OUTPUT][OUTPUT_RES_HEIGHT] * (MULTIPLIER/2),
                                 SETTINGS[WINDOW][WDR_X_POS],
                                 SETTINGS[WINDOW][WDR_Y_POS])
  STR = "NEW_X,',',NEW_Y"
  SEND_COMMAND TP,"'!T',10,STR"
  STR = "ITOA(SETTINGS[WINDOW][WDR_WIDTH]),' X ',ITOA(SETTINGS[WINDOW][WDR_HEIGHT])"
  SEND_COMMAND TP,"'!T',11,STR"
}
  
PUSH[TP,72]                         (* Left Fast Forward *)
{
  IF (MENU = MOVE)
    ACTION = FF_MOVE_LEFT
  ELSE IF (MENU = RESIZE)
    ACTION = RESIZE_SMALL_4TO3
  PULSE[TP,72]
}
PUSH[TP,73]                         (* Right Fast Forward *)
{  
  IF (MENU = MOVE)
    ACTION = FF_MOVE_RIGHT
  ELSE IF (MENU = RESIZE)
    ACTION = RESIZE_BIG_4TO3
  PULSE[TP,73]
}
PUSH[TP,74]                         (* Up Fast Forward *)
{
  IF (MENU = MOVE)
    ACTION = FF_MOVE_UP
  ELSE IF (MENU = RESIZE)
    ACTION = RESIZE_BIG_16TO9
  PULSE[TP,74]
}
PUSH[TP,75]                         (* Down Fast Forward *)
{  
  IF (MENU = MOVE)
    ACTION = FF_MOVE_DOWN
  ELSE IF (MENU = RESIZE)
    ACTION = RESIZE_SMALL_16TO9
  PULSE[TP,75]
}

RELEASE[TP,72]
RELEASE[TP,73]
RELEASE[TP,74]
RELEASE[TP,75]
  ACTION = 0


PUSH[TP,76]                         (* Zoom In *)
{
   PULSE[TP,76]
   CALL 'ZOOM IN' (SuperView,WINDOW)
}
PUSH[TP,77]                         (* Zoom Out *)
{
   PULSE[TP,77]
   CALL 'ZOOM OUT' (SuperView,WINDOW)
}
PUSH[TP,78]                         (* Zoom In Fast Forward *)
  ACTION = FF_ZOOM_IN
[TP,78] = (ACTION = FF_ZOOM_IN)
PUSH[TP,79]                         (* Zoom Out Fast Forward *)
  ACTION = FF_ZOOM_OUT
[TP,79] = (ACTION = FF_ZOOM_OUT)

PUSH[TP,80]                         (* Pan/Zoom Left *)
{
   PULSE[TP,80]
   CALL 'PAN LEFT' (SuperView,WINDOW)
}
PUSH[TP,81]                         (* Pan/Zoom Right *)
{  
   PULSE[TP,81]
   CALL 'PAN RIGHT' (SuperView,WINDOW)
}
PUSH[TP,82]                         (* Pan/Zoom Up *)
{  
   PULSE[TP,82]
   CALL 'PAN UP' (SuperView,WINDOW)
}
PUSH[TP,83]                         (* Pan/Zoom Down *)
{  
   PULSE[TP,83]
   CALL 'PAN DOWN' (SuperView,WINDOW)
}
PUSH[TP,84]                         (* Pan/Zoom Fast Forward Left *)
   ACTION = FF_PAN_LEFT
[TP,84] = (ACTION = FF_PAN_LEFT)
PUSH[TP,85]                         (* Pan/Zoom Fast Forward Right *)
   ACTION = FF_PAN_RIGHT
[TP,85] = (ACTION = FF_PAN_RIGHT)
PUSH[TP,86]                         (* Pan/Zoom Fast Forward Up *)
   ACTION = FF_PAN_UP
[TP,86] = (ACTION = FF_PAN_UP)
PUSH[TP,87]                         (* Pan/Zoom Fast Forward Down *)
   ACTION = FF_PAN_DOWN
[TP,87] = (ACTION = FF_PAN_DOWN)

PUSH[TP,76]
PUSH[TP,77]
PUSH[TP,80]
PUSH[TP,81]
PUSH[TP,82]
PUSH[TP,83]
{
    STR = "ITOA(SETTINGS[WINDOW][WSR_X_POS]),',',ITOA(SETTINGS[WINDOW][WSR_Y_POS]),',',
           ITOA(SETTINGS[WINDOW][WSR_WIDTH]),',',ITOA(SETTINGS[WINDOW][WSR_HEIGHT])"    
    SEND_COMMAND TP,"'!T',13,STR"
}

RELEASE[TP,78]
RELEASE[TP,79]
  ACTION = 0
RELEASE[TP,84]
RELEASE[TP,85]
RELEASE[TP,86]
RELEASE[TP,87]
   ACTION = 0

PUSH[TP,90]                         (* Priority *)
{
   ACTION = PRIORITY
   CALL 'SVWIN00F' (SuperView,PRIORITY,"ITOA(WINDOW),' 1'",0)
}
[TP,90] = (ACTION = PRIORITY)

PUSH[TP,91]                         (* Freeze *)
{
  IF (SETTINGS[WINDOW][FREEZE] = TRUE)
  {
     CALL 'SVWIN00F' (SuperView,FREEZE,"ITOA(WINDOW),' OFF'",0)
     SETTINGS[WINDOW][FREEZE] = FALSE
  }
  ELSE
  {
     CALL 'SVWIN00F' (SuperView,FREEZE,"ITOA(WINDOW),' ON'",0)
     SETTINGS[WINDOW][FREEZE] = TRUE
  }
}
[TP,91] = (SETTINGS[WINDOW][FREEZE] = TRUE)

PUSH[TP,92]                         (* Full Screen *)
{
  PULSE[TP,92]
  CALL 'SVWIN00F' (SuperView,PRIORITY,"ITOA(WINDOW),' 1'",0)
  SETTINGS[WINDOW][WDR_X_POS] = WDR_X_ZERO
  SETTINGS[WINDOW][WDR_Y_POS] = WDR_Y_ZERO
  SETTINGS[WINDOW][WDR_WIDTH]  = TOTAL_WIDTH
  SETTINGS[WINDOW][WDR_HEIGHT] = TOTAL_HEIGHT
  CALL 'Setup WDR Coords' (WINDOW,SETTINGS[WINDOW][WDR_X_POS],SETTINGS[WINDOW][WDR_Y_POS],
                                  SETTINGS[WINDOW][WDR_WIDTH],SETTINGS[WINDOW][WDR_HEIGHT],DATA_STR)
  CALL 'SVWIN00F' (SuperView,WDR,"DATA_STR",0)
}

PUSH[TP,93]                         (* Window On/Off *)
{
  PULSE[TP,93]
  IF (SETTINGS[WINDOW][SET_WINDOW] = TRUE)
  {
    CALL 'SVWIN00F' (SuperView,SET_WINDOW,"ITOA(WINDOW),' OFF'",0)
    SETTINGS[WINDOW][SET_WINDOW] = FALSE
  }
  ELSE
  {
    CALL 'SVWIN00F' (SuperView,SET_WINDOW,"ITOA(WINDOW),' ON'",0)
    SETTINGS[WINDOW][SET_WINDOW] = TRUE
  }
}
(*********** END WINDOW MENU   ***********)

(*********** START OTHER MENU   ***********)
(* channel 16 for setrate *)
PUSH[TP,100]                        (* Plus X,Y setrate *)
{
  PULSE[TP,100]
  PIXEL_JUMP = PIXEL_JUMP + 1
  CALL 'SVWIN00F' (SuperView,SETRATE,"ITOA(PIXEL_JUMP),' ',ITOA(PIXEL_JUMP)",0)
  SEND_COMMAND TP,"'!T',16,ITOA(PIXEL_JUMP)"
}
PUSH[TP,101]                        (* Minus X,Y setrate *)
{
  PULSE[TP,101]
  PIXEL_JUMP = PIXEL_JUMP - 1
  CALL 'SVWIN00F' (SuperView,SETRATE,"ITOA(PIXEL_JUMP),' ',ITOA(PIXEL_JUMP)",0)
  SEND_COMMAND TP,"'!T',16,ITOA(PIXEL_JUMP)"
}
PUSH[TP,102]                        (* Save Config *)
{
  PULSE[TP,102]
  CALL 'SVWIN00F' (SuperView,SAVECONFIG,"",0)
}
PUSH[TP,103]                        (* Test Patterns *)
{
  PULSE[TP,103]
  IF (SETTINGS[OUTPUT][TESTPATTERN] = NOPATTERN)
  {
    SETTINGS[OUTPUT][TESTPATTERN] = COLORBARS
    CALL 'SVWIN00F' (SuperView,TESTPATTERN,"'COLORBARS'",0)
  }
  ELSE
  IF (SETTINGS[OUTPUT][TESTPATTERN] = COLORBARS)
  {
    SETTINGS[OUTPUT][TESTPATTERN] = GRAYSCALE
    CALL 'SVWIN00F' (SuperView,TESTPATTERN,"'GREYSCALE'",0)
  }
  ELSE
  IF (SETTINGS[OUTPUT][TESTPATTERN] = GRAYSCALE)
  {
    SETTINGS[OUTPUT][TESTPATTERN] = MOVINGBARS
    CALL 'SVWIN00F' (SuperView,TESTPATTERN,"'MOVINGBARS'",0)
  }
  ELSE
  IF (SETTINGS[OUTPUT][TESTPATTERN] = MOVINGBARS)
  {
    SETTINGS[OUTPUT][TESTPATTERN] = NOPATTERN
    CALL 'SVWIN00F' (SuperView,TESTPATTERN,"'OFF'",0)
  }
}
(*********** END OTHER MENU   ***********)

(*********** START PRESET MENU   ***********)
PUSH[TP,109]                        (* Start Scripting Demo *)
{  
  IF (ACTION != DEMO)
  {
     STEP = SV_DEMO_1
     ACTION = DEMO
  }
}
[TP,109] = (ACTION = DEMO)

PUSH[TP,110]                        (* Stop Scripting Demo *)
{
   STEP = 0
   ACTION = 0
}
[TP,110] = (ACTION = 0)

PUSH[TP,111]
{
  CALL 'RUN SV DEMO 1'
}

PUSH[TP,112]
{
  CALL 'RUN SV DEMO 2'
}

PUSH[TP,113]
{
  CALL 'RUN SV DEMO 3'
}

PUSH[TP,114]
{
  CALL 'RUN SV DEMO 4'
}

PUSH[TP,115]
{
  CALL 'RUN SV DEMO 5'
}

PUSH[TP,116]
{
  CALL 'RUN SV DEMO 6'
}
(*********** END PRESET MENU   ***********)

IF (WINDOW)
{
  IF (ACTION = FF_PAN_LEFT  OR ACTION = FF_PAN_RIGHT OR
      ACTION = FF_PAN_UP    OR ACTION = FF_PAN_DOWN OR
      ACTION = FF_ZOOM_IN   OR ACTION = FF_ZOOM_OUT)
  {
    IF (ACTION = FF_PAN_LEFT)
       CALL 'PAN LEFT' (SuperView,WINDOW)
    ELSE IF (ACTION = FF_PAN_RIGHT)
       CALL 'PAN RIGHT' (SuperView,WINDOW)
    ELSE IF (ACTION = FF_PAN_UP)
       CALL 'PAN UP' (SuperView,WINDOW)
    ELSE IF (ACTION = FF_PAN_DOWN)
       CALL 'PAN DOWN' (SuperView,WINDOW)
    ELSE IF (ACTION = FF_ZOOM_IN)
       CALL 'ZOOM IN' (SuperView,WINDOW)
    ELSE IF (ACTION = FF_ZOOM_OUT)
       CALL 'ZOOM OUT' (SuperView,WINDOW)
    STR = "ITOA(SETTINGS[WINDOW][WSR_X_POS]),',',ITOA(SETTINGS[WINDOW][WSR_Y_POS]),',',
           ITOA(SETTINGS[WINDOW][WSR_WIDTH]),',',ITOA(SETTINGS[WINDOW][WSR_HEIGHT])"    
    SEND_COMMAND TP,"'!T',13,STR"
  }
  IF (ACTION = FF_MOVE_UP   OR ACTION = FF_MOVE_DOWN OR
      ACTION = FF_MOVE_LEFT OR ACTION = FF_MOVE_RIGHT)
  {
    IF (ACTION = FF_MOVE_UP)
    {
       CALL 'SLIDE WINDOW UP' (SuperView,WINDOW)
    }
    ELSE IF (ACTION = FF_MOVE_DOWN)
    {
       CALL 'SLIDE WINDOW DOWN' (SuperView,WINDOW)
    }
    ELSE IF (ACTION = FF_MOVE_LEFT)
    {
       CALL 'SLIDE WINDOW LEFT' (SuperView,WINDOW)
    }
    ELSE IF (ACTION = FF_MOVE_RIGHT)
    {
       CALL 'SLIDE WINDOW RIGHT' (SuperView,WINDOW)
    }
    CALL 'Negative WDR Converter' (SETTINGS[OUTPUT][OUTPUT_RES_WIDTH] * (MULTIPLIER/2),
                                   SETTINGS[OUTPUT][OUTPUT_RES_HEIGHT] * (MULTIPLIER/2),
                                   SETTINGS[WINDOW][WDR_X_POS],
                                   SETTINGS[WINDOW][WDR_Y_POS])
    STR = "NEW_X,',',NEW_Y"
    SEND_COMMAND TP,"'!T',10,STR"
    
  }
  ELSE IF (ACTION = RESIZE_BIG_4TO3  OR ACTION = RESIZE_SMALL_4TO3 OR
           ACTION = RESIZE_BIG_16TO9 OR ACTION = RESIZE_SMALL_16TO9)
  {
    IF (ACTION = RESIZE_BIG_4TO3)
    {
        CALL 'RESIZE BIGGER 4TO3' (SuperView,WINDOW)
    }
    ELSE IF (ACTION = RESIZE_SMALL_4TO3)
    {
       CALL 'RESIZE SMALLER 4TO3' (SuperView,WINDOW)
    }
    ELSE IF (ACTION = RESIZE_BIG_16TO9)
    {
       CALL 'RESIZE BIGGER 16TO9' (SuperView,WINDOW)
    }
    ELSE IF (ACTION = RESIZE_SMALL_16TO9)
    {
       CALL 'RESIZE SMALLER 16TO9' (SuperView,WINDOW)
    }
    STR = "ITOA(SETTINGS[WINDOW][WDR_WIDTH]),' X ',ITOA(SETTINGS[WINDOW][WDR_HEIGHT])"
    SEND_COMMAND TP,"'!T',11,STR"
  }
}

IF (LENGTH_STRING(TP_BUFFER))
    CALL 'PROCESS TP BUFFER' (TP_BUFFER)


(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)

